//VERSION FINAL PARA MATRIZ DOBLE DE 7 X 10
//PUEDE MANEJAR CARACTERES GRAFICOS
//MUESTRA EL TEXTO INICIALIZADO EN EL STRING "mensaje" EN LA 
//MATRIZ DOBLE DE 7 X 10.PERMITE TEXTOS LARGOS DE CUALQUIER LONGITUD
//DEBE CONSERVARSE EL FORMATO INDICADO, CON 3 PUNTOS ANTES Y 4
//PUNTOS DESPUES DEL MENSAJE, CUALQUIERA QUE SEA SU LONGITUD
//LOS CARACTERES GRAFICOS DE UN CORAZON "%&" Y FLECHA "/(" 
//LOS MANEJA SIN INSERTAR UNA COLUMNA EN BLANCO.
//EL RETRASO EN EL SCROLLING SE CONTROLA CON EL VALOR
//DE LA VARIABLE "VELOCIDAD"

#if defined(__PCM__)
#include "16f88adc.h"
#include <string.h>
#use delay (clock=4000000)
#use rs232 (baud=9600,xmit=PIN_B5,rcv=PIN_B2)
#rom 0X0000={0X018A,0X2803}         
#build(reset=0x0003)

unsigned int longitud;				//AQUI SE ESCRIBE LA LONGITUD DEL MENSAJE
int af,cf,bf=0;							//bf es el elemento del arreglo pf[]
int i;							//variable ndice malla principal 
int k;							//variable ndice para arreglo pf[]
int jota,omega=0;				//variables indice para arreglo pf[]
//AQUI SE ESCRIBE EL MENSAJE CON CUALQUIER LONGITUD************
const char mensaje[]="../(/(FELIZ DIA DEL%&%&...";	//texto que habr de mostrarse, con scrolling
int VELOCIDAD=25;
char pf[40]; 					//arreglo con 36 patrones de columnas (6 caracteres)
#include "LETRASCCS3.h"
int calcula(void);				//funcin calcula longitud de "mensaje[]"
void main()
{
SPEN=0;        				
CVRCON=0;
CMCON=7;
TRISA=0x00;    				
TRISB=0x00;
longitud=calcula();				//calcula longitud de mensaje[]
longitud=longitud-(longitud%4);
malla:
for(omega=0;omega<longitud;omega=omega+4)
{
jota=0;						
	for(k=0;k<6;k++)				//6 caracteres del arreglo "mensaje"
	{
	swatch(mensaje[k+omega]);		//acomoda patrn de columnas en arreglo pf[]
	if(mensaje[k+omega]=='%')goto sigue;  //si es caracter grfico,no aade rengn en blanco
	if(mensaje[k+omega]=='/')goto sigue2;
	pf[jota]=0;	
	jota=jota+1;					//deja una columna en blanco entre caracteres	
	continue;
	sigue:							//si es corazn, aade la columna que falta
	pf[jota]=0x3E;
	jota=jota+1;
	continue;
	sigue2:							//si es flecha, aade la columna que falta
	pf[jota]=0x38;
	jota=jota+1;	
	}			
   		for(bf=0;bf<24;bf++)		//activa el scrolling 24 veces
		{
			for(k=0;k<VELOCIDAD;k++)			//RETRASO EN EL SCROLLING
   			{
   			i=0;        	  			//Inicializamos el contador auxiliar.
   			PORTA=0X00;					//Inicializamos el Puerto A   
   			RA1=1;                     	//Reset al contador
   			delay_us(10);          
   			RA1=0;                     
   	  			for(i=0;i<10;i++)    	  	//malla muestra 10 columnas, 2ms por columna
   	  			{                       	//bf es el elemento del arreglo,i es el offset
      			PORTB=pf[i+bf];           //Mostramos el valor de la columna
	  			delay_ms(1);
	  			RA2=1;                  	//Incrementa el contador         
      			RA2=0;                  
      			}
			PORTB=0;					//evita que encienda brevemente columna 1
   			}
		}
}
goto malla;         					
}

//ESTA FUNCION CALCULA LA LONGITUD DEL STRING "mensaje[]"
//la funcin toma el valor del resultado, que es la variable "af"
int calcula(void)
{
af=0;
	while(1)
	{cf=mensaje[af];
	if(cf==0)return(af);	//ES CARACTER=0?
	af++;
	}
}